﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                string siteCollectionURL = args[0];
                string nameOfPermissionLevel = args[1];
                string description = args[2];

                if (siteCollectionURL == "-help")
                {
                    Console.WriteLine("Usage: CreatePermissionLevel <Site Collection URL> <name of permission level> <description>");
                    Console.WriteLine();
                    Console.WriteLine();
                }
                else
                {
		              using (SPSite oSiteCollection = new SPSite(siteCollectionURL))
		              {
		                using (SPWeb oWebsite = oSiteCollection.OpenWeb())
		                {

			            if (!oWebsite.HasUniqueRoleDefinitions)
			            {
		                        oWebsite.RoleDefinitions.BreakInheritance(true, true);
		                    }

		                    SPRoleDefinition oRoleDefinition = new SPRoleDefinition();
		                    oRoleDefinition.Name = nameOfPermissionLevel;
		                    oRoleDefinition.Description = description;
		                    oRoleDefinition.BasePermissions = SPBasePermissions.AddListItems & SPBasePermissions.ViewFormPages & SPBasePermissions.UseClientIntegration;
		                    oWebsite.RoleDefinitions.Add(oRoleDefinition);
		                }
		              }
                  }
            }
            catch (Exception mainException)
            {

                Console.WriteLine("Usage: CreatePermissionLevel <Site Collection URL> <name of permission level> <description>");
                Console.WriteLine();
                Console.WriteLine();
                Console.WriteLine(mainException.Message);

            }
        }
    }
}
